/*
Sand3d
Copyright (C) 2007 - David Pascoe-Deslauriers

  This file is part of Sand3d.

    Sand3d is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Sand3d is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Sand3d; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <GL/glut.h>

class fountain {
    public:    
        static const int FIRE = 0;
        static const int EXPL = 1;
        
        
        static const int MAX_PARTICLES = 25;
                   
        struct {
        	bool	active;
        	float	life;
        	float	fade;
        	float	r;
        	float	g;
        	float	b;
        	float	x;						// X Position
        	float	y;						// Y Position
        	float	z;						// Z Position
        	float	xi;						// X Direction
        	float	yi;						// Y Direction
        	float	zi;						// Z Direction
        	float	xg;						// X Gravity
        	float	yg;						// Y Gravity
        	float	zg;						// Z Gravity
        } typedef particles;							// Particles Structure
        
		float slowdown;
        int type;
        particles particle[MAX_PARTICLES];	// Particle Array (Room For Particle Info)
        
        fountain(int);
        ~fountain();
        
        void draw(GLuint);
        void step();
        void points(float*,float*,float*);
};
